;;; -*- Mode: lisp -*-

;;; This is just a sample of building series with MK defsystem. You
;;; may need to change :source-pathname appropriately for your system.

(in-package :asdf)

#+cmu
(defclass cl-modifying-file (cl-source-file) ())

#+cmu
(defmethod perform ((op load-op) (c cl-modifying-file))
  (ext:without-package-locks
     (call-next-method)))

#+cmu
(defmethod perform ((op compile-op) (c cl-modifying-file))
  (ext:without-package-locks
     (call-next-method)))

#+cmu
(defmethod source-file-type ((c cl-modifying-file) (s module))
  "lisp")


#+cmu
(defsystem :cmucl-hemlock-base
    :depends-on (:cmucl-clx)
    :components
    ((:file "package")
     (:file "charmacs" :depends-on ("package"))
     (:cl-modifying-file "key-event" :depends-on ("charmacs"))
     (:file "struct" :depends-on ("key-event"))
     ;;"struct-ed"
     (:cl-modifying-file  "rompsite" :depends-on ("struct"))
     (:file "keysym-defs" :depends-on ("rompsite"))
     (:file "input" :depends-on ("keysym-defs"))
     (:file "macros" :depends-on ("input"))
     (:file "line" :depends-on ("macros"))
     (:file "ring" :depends-on ("line"))
     (:file "table" :depends-on ("ring"))
     (:file "htext1" :depends-on ("table"))
     (:file "htext2" :depends-on ("htext1"))
     (:file "htext3" :depends-on ("htext2"))
     (:file "htext4" :depends-on ("htext3"))
     (:file "search1" :depends-on ("htext4"))
     (:file "search2" :depends-on ("search1"))
     (:file "linimage" :depends-on ("search2"))
     (:file "cursor" :depends-on ("linimage"))
     (:file "syntax" :depends-on ("cursor"))
     (:file "winimage" :depends-on ("syntax"))
     (:file "hunk-draw" :depends-on ("winimage"))
     ;;"bit-stream"
     (:file "termcap" :depends-on ("hunk-draw"))
     (:file "display" :depends-on ("termcap"))
     (:file "bit-display" :depends-on ("display"))
     (:file "tty-disp-rt" :depends-on ("bit-display"))
     (:file "tty-display" :depends-on ("tty-disp-rt"))
     ;;"tty-stream"
     (:file "pop-up-stream" :depends-on ("tty-display"))
     (:file "window" :depends-on ("pop-up-stream"))
     (:file "screen" :depends-on ("window"))
     (:file "bit-screen" :depends-on ("screen"))
     (:file "tty-screen" :depends-on ("bit-screen"))
     (:file "font" :depends-on ("tty-screen"))
     (:file "interp" :depends-on ("font"))
     (:file "vars" :depends-on ("interp"))
     (:file "buffer" :depends-on ("vars"))
     (:file "files" :depends-on ("buffer"))
     (:file "streams" :depends-on ("files"))
     (:cl-modifying-file "main" :depends-on ("streams"))
     (:file "echo" :depends-on ("main"))
     (:file "echocoms" :depends-on ("echo"))
     (:file "morecoms" :depends-on ("echocoms"))
     (:file "defsyn" :depends-on ("morecoms"))
     (:file "ts-buf" :depends-on ("defsyn"))
     (:file "ts-stream" :depends-on ("ts-buf"))
     (:file "command" :depends-on ("ts-stream"))
     (:file "undo" :depends-on ("command"))
     (:file "killcoms" :depends-on ("undo"))
     (:file "searchcoms" :depends-on ("killcoms"))
     (:file "filecoms" :depends-on ("searchcoms"))
     (:file "indent" :depends-on ("filecoms"))
     (:file "lispmode" :depends-on ("indent"))
     (:file "comments" :depends-on ("lispmode"))
     (:file "fill" :depends-on ("comments"))
     (:file "text" :depends-on ("fill"))
     (:file "doccoms" :depends-on ("text"))
     (:file "srccom" :depends-on ("doccoms"))
     (:file "abbrev" :depends-on ("srccom"))
     (:file "group" :depends-on ("abbrev"))
     (:file "overwrite" :depends-on ("group"))
     (:file "gosmacs" :depends-on ("overwrite"))
     (:file "eval-server" :depends-on ("gosmacs"))
     (:file "scribe" :depends-on ("eval-server"))
     (:file "dylan" :depends-on ("scribe"))
     (:file "lispbuf" :depends-on ("dylan"))
     (:file "lispeval" :depends-on ("lispbuf"))
     (:file "icom" :depends-on ("lispeval"))
     (:file "hi-integrity" :depends-on ("icom"))
     (:file "ed-integrity" :depends-on ("hi-integrity"))
     (:file "pascal" :depends-on ("ed-integrity"))
     (:file "edit-defs" :depends-on ("pascal"))
     (:file "auto-save" :depends-on ("edit-defs"))
     (:file "register" :depends-on ("auto-save"))
     (:file "xcoms" :depends-on ("register"))
     (:file "unixcoms" :depends-on ("xcoms"))
     (:file "mh" :depends-on ("unixcoms"))
     (:file "highlight" :depends-on ("mh"))
     (:file "dired" :depends-on ("highlight"))
     (:file "diredcoms" :depends-on ("dired"))
     (:file "bufed" :depends-on ("diredcoms"))
     (:file "lisp-lib" :depends-on ("bufed"))
     (:file "completion" :depends-on ("lisp-lib"))
     (:file "shell" :depends-on ("completion"))
     (:file "debug" :depends-on ("shell"))
     (:file "netnews" :depends-on ("debug"))
     (:file "rcs" :depends-on ("netnews"))
     (:file "spell-rt" :depends-on ("rcs"))
     (:file "spell-corr" :depends-on ("spell-rt"))
     (:file "spell-aug" :depends-on ("spell-corr"))
     (:file "spell-build" :depends-on ("spell-aug"))
     (:file "spellcoms" :depends-on ("spell-build"))
     (:file "kbdmac" :depends-on ("spellcoms"))
     (:file "dabbrev" :depends-on ("kbdmac"))
     (:file "bindings" :depends-on ("dabbrev"))
     (:file "hacks" :depends-on ("bindings"))
     ))

